
# Imputamos el test con los datos del train.

CraftAndImputePredict <- function(trainSet, testSet, as_tibble=F, group="HY_cod_postal"){
    tipos <- c('Almacen','Aparcamiento', 'Edificio turistico',
               'Otro', 'Edificio comercial', 'Trastero', 'Garaje', 'Solar', 'Suelo rustico no urbanizable')
    data <- trainSet
    dataTest <- testSet
    dataTest %<>% 
        mutate(HY_cert_energ = ifelse(is.na(HY_cert_energ) & HY_tipo %in% tipos, "NoAplica", 
                                      ifelse(is.na(HY_cert_energ),"DeberiaPeroNo",HY_cert_energ))) 
    dataTest$HY_cert_energ <- dataTest$HY_cert_energ %>% as.factor()
    
    #Eliminamos variables innecesarias con muchos NA
    dataTest %<>% select(-IDEA_ind_liquidez)
    dataTest %<>% select(-HY_metros_utiles)
    dataTest %<>% select(-IDEA_pc_1960, -IDEA_pc_1960_69, -IDEA_pc_1970_79, -IDEA_pc_1980_89, 
                     -IDEA_pc_1990_99, -IDEA_pc_2000_10)
    ##Imputacion NA
    
    dataTest %<>% left_join(
        data %>% select_(group,"HY_antiguedad") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(AntiguedadGroupedMedian = median(HY_antiguedad)), by=group
    ) 
    dataTest$AntiguedadGroupedMedian[is.na(dataTest$AntiguedadGroupedMedian)] <- median(data$HY_antiguedad,na.rm = T)
    dataTest %<>% mutate(HY_antiguedad = ifelse(is.na(HY_antiguedad), AntiguedadGroupedMedian,HY_antiguedad),
                         HY_antiguedad = as.integer(HY_antiguedad)) 
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_ind_elasticidad") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(ElasGroupedMedian = median(IDEA_ind_elasticidad)), by=group
    ) 
    dataTest$ElasGroupedMedian[is.na(dataTest$ElasGroupedMedian)] <- median(data$IDEA_ind_elasticidad,na.rm = T)
    dataTest %<>% mutate(IDEA_ind_elasticidad = if_else(is.na(IDEA_ind_elasticidad), ElasGroupedMedian,IDEA_ind_elasticidad),
                         IDEA_ind_elasticidad = as.integer(IDEA_ind_elasticidad)) 
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_rent_alquiler") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(RentAlqGroupedMedian = median(IDEA_rent_alquiler)), by=group
    ) 
    dataTest$RentAlqGroupedMedian[is.na(dataTest$RentAlqGroupedMedian)] <- median(data$IDEA_rent_alquiler,na.rm = T)
    dataTest %<>% mutate(IDEA_rent_alquiler = if_else(is.na(IDEA_rent_alquiler), RentAlqGroupedMedian,IDEA_rent_alquiler),
                         IDEA_rent_alquiler = as.integer(IDEA_rent_alquiler)) 
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_unitprice_rent_residential") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(UnRentAlqGroupedMedian = median(IDEA_unitprice_rent_residential)), by=group
    ) 
    dataTest$UnRentAlqGroupedMedian[is.na(dataTest$UnRentAlqGroupedMedian)] <- median(data$IDEA_unitprice_rent_residential,na.rm = T)
    dataTest %<>% mutate(IDEA_unitprice_rent_residential = if_else(is.na(IDEA_unitprice_rent_residential), UnRentAlqGroupedMedian,IDEA_unitprice_rent_residential),
                         IDEA_unitprice_rent_residential = as.integer(IDEA_unitprice_rent_residential)) 
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_price_rent_residential") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(PriceRentRGroupedMedian = median(IDEA_price_rent_residential)), by=group
    ) 
    dataTest$PriceRentRGroupedMedian[is.na(dataTest$PriceRentRGroupedMedian)] <- median(data$IDEA_price_rent_residential,na.rm = T)
    dataTest %<>% mutate(IDEA_price_rent_residential = if_else(is.na(IDEA_price_rent_residential), PriceRentRGroupedMedian,IDEA_price_rent_residential),
                         IDEA_price_rent_residential = as.integer(IDEA_price_rent_residential)) 
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_stock_rent_residential") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(StockRentRGroupedMedian = median(IDEA_stock_rent_residential)), by=group
    ) 
    dataTest$StockRentRGroupedMedian[is.na(dataTest$StockRentRGroupedMedian)] <- median(data$IDEA_stock_rent_residential,na.rm = T)
    dataTest %<>% mutate(IDEA_stock_rent_residential = ifelse(is.na(IDEA_stock_rent_residential), StockRentRGroupedMedian,IDEA_stock_rent_residential),
                         IDEA_stock_rent_residential = as.integer(IDEA_stock_rent_residential)) 
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_pc_comercio") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(PcComerGroupedMedian = median(IDEA_pc_comercio)), by=group
    ) 
    dataTest$PcComerGroupedMedian[is.na(dataTest$PcComerGroupedMedian)] <- median(data$IDEA_pc_comercio,na.rm = T)
    dataTest %<>% mutate(IDEA_pc_comercio = if_else(is.na(IDEA_pc_comercio), PcComerGroupedMedian,IDEA_pc_comercio),
                         IDEA_pc_comercio = as.integer(IDEA_pc_comercio)) 
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_pc_industria") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(PCIndusGroupedMedian = median(IDEA_pc_industria)), by=group
    ) 
    dataTest$PCIndusGroupedMedian[is.na(dataTest$PCIndusGroupedMedian)] <- median(data$IDEA_pc_industria,na.rm = T)
    dataTest %<>% mutate(IDEA_pc_industria = if_else(is.na(IDEA_pc_industria), PCIndusGroupedMedian,IDEA_pc_industria),
                         IDEA_pc_industria = as.integer(IDEA_pc_industria))
    
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_pc_oficina") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(PCOfiGroupedMedian = median(IDEA_pc_oficina)), by=group
    ) 
    dataTest$PCOfiGroupedMedian[is.na(dataTest$PCOfiGroupedMedian)] <- median(data$IDEA_pc_oficina,na.rm = T)
    dataTest %<>% mutate(IDEA_pc_oficina = if_else(is.na(IDEA_pc_oficina), PCOfiGroupedMedian,IDEA_pc_oficina),
                         IDEA_pc_oficina = as.integer(IDEA_pc_oficina))
    
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_pc_otros") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(PCOtroGroupedMedian = median(IDEA_pc_otros)), by=group
    ) 
    dataTest$PCOtroGroupedMedian[is.na(dataTest$PCOtroGroupedMedian)] <- median(data$IDEA_pc_otros,na.rm = T)
    dataTest %<>% mutate(IDEA_pc_otros = if_else(is.na(IDEA_pc_otros), PCOtroGroupedMedian,IDEA_pc_otros),
                         IDEA_pc_otros = as.integer(IDEA_pc_otros))
    
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_pc_residencial") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(PCResiGroupedMedian = median(IDEA_pc_residencial)), by=group
    ) 
    dataTest$PCResiGroupedMedian[is.na(dataTest$PCResiGroupedMedian)] <- median(data$IDEA_pc_residencial,na.rm = T)
    dataTest %<>% mutate(IDEA_pc_residencial = if_else(is.na(IDEA_pc_residencial), PCResiGroupedMedian,IDEA_pc_residencial),
                         IDEA_pc_residencial = as.integer(IDEA_pc_residencial))
    
    
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_pc_trast_parking") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(PCTrastParkGroupedMedian = median(IDEA_pc_trast_parking)), by=group
    ) 
    dataTest$PCTrastParkGroupedMedian[is.na(dataTest$PCTrastParkGroupedMedian)] <- median(data$IDEA_pc_trast_parking,na.rm = T)
    dataTest %<>% mutate(IDEA_pc_trast_parking = if_else(is.na(IDEA_pc_trast_parking), PCTrastParkGroupedMedian,IDEA_pc_trast_parking),
                         IDEA_pc_trast_parking = as.integer(IDEA_pc_trast_parking))
    
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_ind_tienda") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(IndTienGroupedMedian = median(IDEA_ind_tienda)), by=group
    ) 
    dataTest$IndTienGroupedMedian[is.na(dataTest$IndTienGroupedMedian)] <- median(data$IDEA_ind_tienda,na.rm = T)
    dataTest %<>% mutate(IDEA_ind_tienda = if_else(is.na(IDEA_ind_tienda), IndTienGroupedMedian,IDEA_ind_tienda),
                         IDEA_ind_tienda = as.integer(IDEA_ind_tienda))
    
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_ind_turismo") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(IndTurisGroupedMedian = median(IDEA_ind_turismo)), by=group
    ) 
    dataTest$IndTurisGroupedMedian[is.na(dataTest$IndTurisGroupedMedian)] <- median(data$IDEA_ind_turismo,na.rm = T)
    dataTest %<>% mutate(IDEA_ind_turismo = if_else(is.na(IDEA_ind_turismo), IndTurisGroupedMedian,IDEA_ind_turismo),
                         IDEA_ind_turismo = as.integer(IDEA_ind_turismo))
    
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_ind_alimentacion") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(IndAliGroupedMedian = median(IDEA_ind_alimentacion)), by=group
    ) 
    dataTest$IndAliGroupedMedian[is.na(dataTest$IndAliGroupedMedian)] <- median(data$IDEA_ind_alimentacion,na.rm = T)
    dataTest %<>% mutate(IDEA_ind_alimentacion = if_else(is.na(IDEA_ind_alimentacion), IndAliGroupedMedian,IDEA_ind_alimentacion),
                         IDEA_ind_alimentacion = as.integer(IDEA_ind_alimentacion))
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_area") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(AreaGroupedMedian = median(IDEA_area)), by=group
    ) 
    dataTest$AreaGroupedMedian[is.na(dataTest$AreaGroupedMedian)] <- median(data$IDEA_area,na.rm = T)
    dataTest %<>% mutate(IDEA_area = if_else(is.na(IDEA_area), AreaGroupedMedian,IDEA_area),
                         IDEA_area = as.integer(IDEA_area))
    
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_poblacion") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(PobGroupedMedian = median(IDEA_poblacion)), by=group
    ) 
    dataTest$PobGroupedMedian[is.na(dataTest$PobGroupedMedian)] <- median(data$IDEA_poblacion,na.rm = T)
    dataTest %<>% mutate(IDEA_poblacion = ifelse(is.na(IDEA_poblacion), PobGroupedMedian,IDEA_poblacion),
                         IDEA_poblacion = as.integer(IDEA_poblacion))
    
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_densidad") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(DenGroupedMedian = median(IDEA_densidad)), by=group
    ) 
    dataTest$DenGroupedMedian[is.na(dataTest$DenGroupedMedian)] <- median(data$IDEA_densidad,na.rm = T)
    dataTest %<>% mutate(IDEA_densidad = if_else(is.na(IDEA_densidad), DenGroupedMedian,IDEA_densidad),
                         IDEA_densidad = as.integer(IDEA_densidad))
    
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_ind_riqueza") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(RiqGroupedMedian = median(IDEA_ind_riqueza)), by=group
    ) 
    dataTest$RiqGroupedMedian[is.na(dataTest$RiqGroupedMedian)] <- median(data$IDEA_ind_riqueza,na.rm = T)
    dataTest %<>% mutate(IDEA_ind_riqueza = if_else(is.na(IDEA_ind_riqueza), RiqGroupedMedian,IDEA_ind_riqueza),
                         IDEA_ind_riqueza = as.integer(IDEA_ind_riqueza))
    
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_unitprice_sale_residential") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(USResGroupedMedian = median(IDEA_unitprice_sale_residential)), by=group
    ) 
    dataTest$USResGroupedMedian[is.na(dataTest$USResGroupedMedian)] <- median(data$IDEA_unitprice_sale_residential,na.rm = T)
    dataTest %<>% mutate(IDEA_unitprice_sale_residential = if_else(is.na(IDEA_unitprice_sale_residential), USResGroupedMedian,IDEA_unitprice_sale_residential),
                         IDEA_unitprice_sale_residential = as.integer(IDEA_unitprice_sale_residential))
    
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_price_sale_residential") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(PricSGroupedMedian = median(IDEA_price_sale_residential)), by=group
    ) 
    dataTest$PricSGroupedMedian[is.na(dataTest$PricSGroupedMedian)] <- median(data$IDEA_price_sale_residential,na.rm = T)
    dataTest %<>% mutate(IDEA_price_sale_residential = if_else(is.na(IDEA_price_sale_residential), PricSGroupedMedian,IDEA_price_sale_residential),
                         IDEA_price_sale_residential = as.integer(IDEA_price_sale_residential))
    
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_stock_sale_residential") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(StSalGroupedMedian = median(IDEA_stock_sale_residential)), by=group
    ) 
    dataTest$StSalGroupedMedian[is.na(dataTest$StSalGroupedMedian)] <- median(data$IDEA_stock_sale_residential,na.rm = T)
    dataTest %<>% mutate(IDEA_stock_sale_residential = ifelse(is.na(IDEA_stock_sale_residential), StSalGroupedMedian,IDEA_stock_sale_residential),
                         IDEA_stock_sale_residential = as.integer(IDEA_stock_sale_residential))
    
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_demand_sale_residential") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(DSaleGroupedMedian = median(IDEA_demand_sale_residential)), by=group
    ) 
    dataTest$DSaleGroupedMedian[is.na(dataTest$DSaleGroupedMedian)] <- median(data$IDEA_demand_sale_residential,na.rm = T)
    dataTest %<>% mutate(IDEA_demand_sale_residential = if_else(is.na(IDEA_demand_sale_residential), DSaleGroupedMedian,IDEA_demand_sale_residential),
                         IDEA_demand_sale_residential = as.integer(IDEA_demand_sale_residential))
    
    
    
    dataTest %<>% left_join(
        data %>% select_(group,"IDEA_demand_rent_residential") %>% 
            na.omit() %>% group_by_(group)%>% 
            summarise(DRentGroupedMedian = median(IDEA_demand_rent_residential)), by=group
    ) 
    dataTest$DRentGroupedMedian[is.na(dataTest$DRentGroupedMedian)] <- median(data$IDEA_demand_rent_residential,na.rm = T)
    dataTest %<>% mutate(IDEA_demand_rent_residential = if_else(is.na(IDEA_demand_rent_residential), DRentGroupedMedian,IDEA_demand_rent_residential),
                         IDEA_demand_rent_residential = as.integer(IDEA_demand_rent_residential))
    
    
    dataTest %<>% select(-contains("GroupedMedian")) 
    
    
    dataTest$IDEA_ind_elasticidad[is.na(dataTest$IDEA_ind_elasticidad)] <- 1
    
    ############### NUEVAS VARIABLES AGRUPADAS POR CLUSTER
    
    dataTest %<>% left_join(
        data %>% group_by(Cluster_TipoProvPreciom2) %>% summarise(Cluster_TPPm2_Target = median(TARGET))
    )
    dataTest %<>% left_join(
        data %>% group_by(Cluster_TipoProvGA) %>% summarise(Cluster_TipoProvGA_Target = median(TARGET))
    )
    
    dataTest %<>% left_join(
        data %>% group_by(Cluster_TipoProvPreciom2) %>% summarise(Cluster_TPPm2_GA_page_views = median(GA_page_views))
    )
    dataTest %<>% left_join(
        data %>% group_by(Cluster_TipoProvGA) %>% summarise(Cluster_TipoProvGA_GA_page_views = median(GA_page_views))
    )
    
    dataTest %<>% left_join(
        data %>% group_by(Cluster_TipoProvPreciom2) %>% summarise(Cluster_TPPm2_Precio_m2 = median(Precio_m2))
    )
    dataTest %<>% left_join(
        data %>% group_by(Cluster_TipoProvGA) %>% summarise(Cluster_TipoProvGA_Precio_m2 = median(Precio_m2))
    )
    
    dataTest %<>% left_join(
        data %>% group_by(Cluster_TipoProvPreciom2) %>% summarise(Cluster_TPPm2_Precio_m2 = median(Views_interaccion))
    )
    dataTest %<>% left_join(
        data %>% group_by(Cluster_TipoProvGA) %>% summarise(Cluster_TipoProvGA_Precio_m2 = median(Views_interaccion))
    )
    
    dataTest %<>% left_join(
        data %>% group_by(Cluster_TipoProvPreciom2) %>% summarise(Cluster_TPPm2_Num_Fotos = median(Num_Fotos))
    )
    dataTest %<>% left_join(
        data %>% group_by(Cluster_TipoProvGA) %>% summarise(Cluster_TipoProvGA_Num_Fotos = median(Num_Fotos))
    )
    dataTest %<>% left_join(
        data %>% group_by(Cluster_TipoProvPreciom2) %>% summarise(Cluster_TPPm2_VisitasXquincena = median(VisitasXquincena))
    )
    dataTest %<>% left_join(
        data %>% group_by(Cluster_TipoProvGA) %>% summarise(Cluster_TipoProvGA_VisitasXquincena = median(VisitasXquincena))
    )
    
    #Imputacion NA Vizcaya
    # dataTest[dataTest$HY_id == 6082847, 'DensidadPob'] <- 517.95
    # dataTest[dataTest$HY_id == 6082847, 'PIB_Capita'] <- 28900
    # 
    # 
    # dataTest[dataTest$HY_id == 6082847, 'HY_provincia'] <- 'Navarra'
    
    dataCrafted <- dataTest
    if(as_tibble)
        dataCrafted <- data %>% as_tibble()
    return(dataCrafted)
}

