GeneralPreproces <- function(data, ModelarSet = NULL ,as_tibble=F){
    data %<>% mutate(Tiene_Descripcion = if_else(is.na(HY_descripcion), 0, 1),
                     Tiene_Distribucion = if_else(is.na(HY_distribucion), 0, 1), 
                     Tiene_Antiguedad = if_else(is.na(HY_antiguedad), 0, 1), 
                     Tiene_Certificado = if_else(is.na(HY_cert_energ), 0, 1),
                     Tiene_PrecioAnterior = if_else(is.na(HY_precio_anterior), 0, 1)
                     
    )
    ## NAS
    data[data$HY_id == 6840200, 'HY_provincia'] <- 'Almeria'
    data[data$HY_id == 6945209, 'HY_provincia'] <- 'Malaga'
    data[data$HY_id == 6037768, 'HY_metros_totales'] <- 11.16
    data[data$HY_id == 6938820, 'HY_metros_totales'] <- 46016
    data[data$HY_id == 6043715, 'HY_metros_totales'] <- 40
    almeriaIds <- c(6840189,6840191,6886472,6889813,6891015,6891903,6941076,6941069,6967654,
                    6950466,6945330,6956550,6967666,6956561,6955898,6955896,6976437,6950388,7017665)
    alicanteIds <- c(6934509,6938531,6939888,6943587,6943595,6945184,6946631,6945302,6941648)
    murciaIds <- c(6841410,6841429,6886581,6886586,6934617,6937582,6937853,6964628,6969484,6969470 )
    data[data$HY_id %in% almeriaIds, "HY_provincia"] <- "Almeria"
    data[data$HY_id %in% alicanteIds, "HY_provincia"] <- "Alicante"
    data[data$HY_id %in% murciaIds, "HY_provincia"] <- "Murcia"
    data[data$HY_id == 6967747, 'HY_provincia'] <- 'Badajoz'
    data[data$HY_id == 6967629, 'HY_provincia'] <- 'Barcelona'
    data[data$HY_id == 6714472, 'HY_provincia'] <- 'Malaga'
    data[data$HY_id == 6950467, 'HY_provincia'] <- 'Baleares'
    data[data$HY_cod_postal == 15009, 'HY_provincia'] <- 'A Coruna'
    data[data$HY_cod_postal == 15007, 'HY_provincia'] <- 'A Coruna'
    
    #Metros totales en descripcion
    data[data$HY_id == 6031274, 'HY_metros_totales'] <- 2244
    data[data$HY_id == 6031943, 'HY_metros_totales'] <- 296
    data[data$HY_id == 6037690, 'HY_metros_totales'] <- 20.8
    data[data$HY_id == 6077186, 'HY_metros_totales'] <- 97
    data[data$HY_id == 6079044, 'HY_metros_totales'] <- 20
    data[data$HY_id == 6136395, 'HY_metros_totales'] <- 49680
    data[data$HY_id == 6934517, 'HY_metros_totales'] <- 1009

    ####################################### NUEVAS VARAIBLES ####################################
    
    data %<>% mutate(HY_descripcion=as.character(HY_descripcion)) %>% 
        replace_na(list(HY_descripcion="")) %>%  mutate(Descript_Ncaracteres=str_count(HY_descripcion))
    data %<>% mutate(HY_distribucion=as.character(HY_distribucion)) %>% 
        replace_na(list(HY_distribucion="")) %>%  mutate(Distrib_Ncaracteres=str_count(HY_distribucion))
    data %<>% select(-HY_distribucion, -HY_descripcion)
    
    #Creacion n quincenas
    data %<>% mutate(N_Quincenas = (GA_quincena_ult - GA_quincena_ini) +1)
    data$HY_provincia <- as.character(data$HY_provincia )
    data[data$HY_id == 6082847, 'HY_provincia'] <- 'Navarra'
    
    DensidadPob<- c(140.92 , 26.13 , 334.23 , 79.7, 96.91, 19.96, 31.07, 222.97, 721, 25.54, 19.95, 
                    166.55, 87.25, 25.37, 57.24, 11.59, 126.53, 72.41, 21.33, 51.27, 14.06, 48.47,
                    62.84, 269.73, 30.05, 36.46, 820.59, 223.13, 129.34, 62.32, 20.09, 209.73, 23.37,
                    138.20, 8.7, 125.77, 301.25, 9.09, 44.69, 239.59, 64.2, 55.2)
    provincia<- unique(data$HY_provincia) %>% sort
    poblacion <- data.frame(DensidadPob, HY_provincia=provincia,stringsAsFactors = F)
    
    data %<>% left_join(
        poblacion %>% select(DensidadPob, HY_provincia))
    
    PIB_Capita<- c(22000,18200,17500,16900,21400,19200,16000,24000,27000,27500,16000,17000,23000,18500,
                   16500,18750,27000,16500,20000,18000,26000,16000,26000,20000,21000,27000,30000,17500,18500,
                   29500,23000,20000,22000,18500,24000,27000,19500,25000,17500,21500,24500,25500)
    pibCapita <- data.frame(PIB_Capita, HY_provincia=provincia,stringsAsFactors = F)
    
    data %<>% left_join(
        pibCapita %>% select(PIB_Capita, HY_provincia))
    
    # Tiene fotos
    data %<>% mutate(Tiene_Fotos = 0) 
    imageIds <- read_rds("./Data/ImageIds.RDS")
    data %<>% mutate(Tiene_Fotos = if_else(HY_id %in% imageIds, 1, 0))
    
    # Numero de fotos
    nImagesIds <- read_rds("./Data/ImageIdsCount.RDS") %>% mutate(Ids=as.numeric(Ids))
    data %<>% left_join(nImagesIds, by=c("HY_id" = "Ids")) 
    data$Num_Fotos[is.na(data$Num_Fotos)] <- 0
    dimImagesIds <- rbind(read_rds("./Data/FileDimsTrain.RDS"),read_rds("./Data/FileDimsPredict.RDS")) %>% 
        set_names("Foto_W","Foto_h","Foto_c","Foto_Lum","HY_id") %>% select(-Foto_c) %>% mutate(HY_id=as.numeric(HY_id))
    data %<>% left_join(dimImagesIds) %>% replace_na(list("Foto_Lum"=0,"Foto_h"=0,"Foto_W"=0))
    
    #Creacion variable n_compraventas
    N_cv_general<- c(6274,2710,34631,8947,7765,1135,4356,15799,53773,3183,2384,10738,7099,2988,5634,1411,
                     10353,9120,2895,4884,2401,4371,3017,11682,2824,3407,69966,30300,13386,5090,1273,4984,
                     1444,14663,684,10297,11604,860,6471,26437,4476,8893)
    
    general <- data.frame(N_cv_general, HY_provincia=provincia,stringsAsFactors = F)
    data %<>% left_join(
        general %>% select(N_cv_general, HY_provincia))
    
    N_cv_nueva<- c(1444,628,5407,2271,1740,293,435,2725,6636,756,195,2629,770,464,790,113,1559,1650,575,1072,
                   422,607,582,2310,822,537,14967,5588,2061,1052,196,1237,234,1677,232,1461,2245,170,1081,3204,
                   891,1482)
    
    nueva <- data.frame(N_cv_nueva, HY_provincia=provincia,stringsAsFactors = F)
    
    data %<>% left_join(
        nueva %>% select(N_cv_nueva, HY_provincia))
    
    #Creacion usada
    
    data %<>%  mutate(N_cv_usada = N_cv_general-N_cv_nueva)
    
    #Viviendas vacías
    
    Viv_vacias <- c(120069,36331,209024,73291,82857,25696,63097,71255,283155,35990,42076,76009,82003,46432,
                    55676,22406,55460,93098,20770,33324,21186,58921,35745,76900,58812,37165,263279,120611,
                    129117,35466,16725,78152,18964,126290,12430,72577,61362,15355,76718,214002,36319,
                    63796)
    vacias <- data.frame(Viv_vacias, HY_provincia=provincia, stringsAsFactors = F)
    
    data %<>% left_join(
        vacias %>% select(Viv_vacias, HY_provincia))
    
    # Discretizacion 2dimensional para agrupar provincias similares por PIB y densidad de poblacion
    datatip <- scale(unique(data %>% select(PIB_Capita,DensidadPob)))
    
    k1 <- kmeans(datatip, 4)
    
    # plotcluster(unique(datatip), k1$cluster,)
    
    datatip %<>% cbind(Cluster=as.factor(k1$cluster), Provincia = as.character(unique(data$HY_provincia))) %>% as_tibble()
    datatip %<>% mutate(DensidadPob = as.numeric(DensidadPob),
                        PIB_Capita = as.numeric(PIB_Capita)) 
    
    # ggplot(datatip, aes(DensidadPob, PIB_Capita, col=as.factor(Cluster))) +
    #     geom_point() +
    #     geom_text(aes(label=Provincia), size=3, nudge_y = 0.2)
    
    data$HY_precio[is.na(data$HY_precio)] <- 0
    data %<>% mutate(HY_precio = ifelse(HY_precio==0, HY_precio_anterior, HY_precio ))
    data %<>% filter(HY_precio!=0)  # no hay precio NA ni 0 sin precio anterior en el predict.
    
    #Sustituir el valor NA de metros_totales por metros utiles
    data$HY_metros_totales[data$HY_metros_totales==0] <- NA
    data %<>% mutate(HY_metros_totales= ifelse(is.na(HY_metros_totales),
                                               HY_metros_utiles, HY_metros_totales))
    data$HY_metros_totales[data$HY_metros_totales==0] <- NA
    data %<>% filter(!is.na(HY_metros_totales))
    
    data %<>% mutate(Precio_m2 = HY_precio/HY_metros_totales) 
    
    #Creacion de columna cluster a DATA
    data %<>% left_join(datatip %>% select(Cluster, Provincia), by= c("HY_provincia"="Provincia")) 
    data$Cluster <- as.factor(data$Cluster)
    
    #Creacion columna Precio por tipo en funcion de la media del cluster y del tipo
    data %<>% left_join(
        data %>% select(Cluster,HY_tipo, HY_precio) %>% 
            na.omit() %>% group_by(Cluster, HY_tipo)%>% 
            summarise(Precio_Tipo_cluster = median(HY_precio)), by= c('Cluster', 'HY_tipo')
    ) 
    
    #Creacion columna Precio/m2 por tipo en funcion de la media del cluster y del tipo
    data %<>% left_join(
        data %>% select(Cluster,HY_tipo, Precio_m2) %>% 
            na.omit() %>% group_by(Cluster, HY_tipo)%>% 
            summarise(Pm2_Tipo_cluster = median(Precio_m2)), by= c('Cluster', 'HY_tipo')
    ) 
    
    data$Pm2_Tipo_cluster <- round(data$Pm2_Tipo_cluster, 2)
    
    #Creacion visitas por tipo en función de la media del cluster y del tipo
    
    data %<>% left_join(
        data %>% select(Cluster,HY_tipo, GA_page_views) %>% 
            na.omit() %>% group_by(Cluster, HY_tipo)%>% 
            summarise(Visitas_T_C = median(GA_page_views)), by= c('Cluster', 'HY_tipo')
    ) 
    
    #Cambiar NA en precio anterior por el valor del precioa actual
    
    data %<>% mutate(HY_precio_anterior= ifelse(is.na(HY_precio_anterior),
                                                HY_precio, HY_precio_anterior))
    
    data %<>% mutate(DiffPerc_Precio = (HY_precio - HY_precio_anterior)/HY_precio_anterior)
    data %<>% mutate(Page_View_Per_Qincena = GA_page_views/N_Quincenas)
    
    #Creación views con interacción
    
    data %<>% mutate(Views_interaccion = (100-GA_mean_bounce)/100*GA_page_views)
    
    
    #Creación visitas x quincena
    
    data %<>% mutate(VisitasXquincena = GA_page_views/N_Quincenas)
    
    #Creación visitascon interaccion x quincena
    
    data %<>% mutate(VisitasInteraccionXquincena = Views_interaccion/N_Quincenas)
    
    data$VisitasXquincena <- round(data$VisitasXquincena, 2)
    
    #Cuantiles
    
    data$Visitas_discreta <- data %>% pull(GA_page_views) %>% ntile(10)
    data$MediaBounce_discreta <- data %>% pull(GA_mean_bounce) %>% ntile(10)
    data$Exit_discreta <- data %>% pull(GA_exit_rate) %>% ntile(10)
    
    data$HY_provincia <- as.factor(data$HY_provincia)
    data$HY_tipo <- as.factor(data$HY_tipo)

    datatip <- data
    medianAntiguedad <- median(datatip$HY_antiguedad,na.rm = T) %>% as.numeric
    datatip$HY_antiguedad[is.na(datatip$HY_antiguedad)] <- median(datatip$HY_antiguedad,na.rm = T)
    
    ########## OTROS CLUSTERS (con mas variables. 1 con variables del anuncio y el otro con economicas)
    datatip2 <- scale(datatip %>% select(HY_tipo,HY_antiguedad,HY_provincia,GA_page_views,GA_mean_bounce) %>%
                         mutate_if(is.factor, funs(as.numeric)))
    # fviz_nbclust(x = datatip, FUNcluster = kmeans, method = "wss", k.max = 15,
    #              diss = dist(datatip, method = "manhattan"))
    k1 <- kmeans(datatip2, 7)
    
    data %<>% mutate(Cluster_TipoProvGA = as.factor(k1$cluster))
    
    
    datatip3 <- scale(datatip %>% select(HY_tipo,HY_antiguedad,HY_provincia,HY_precio,HY_metros_totales) %>% 
                         mutate_if(is.factor, funs(as.numeric)))

    clara_clusters <- clara(x = datatip3, k = 8, metric = "manhattan", stand = TRUE,
                            samples = 50, pamLike = TRUE)
    
    data %<>% mutate(Cluster_TipoProvPreciom2 = as.factor(clara_clusters$clustering))
    
    dataCrafted <- data
    if(as_tibble)
        dataCrafted <- data %>% as_tibble()
    
    return(dataCrafted)
}
