source("Functions/CraftAndImputeTrain.R")
source("Functions/CraftAndImputePredict.R")


if(section == "train"){
    browser()
    trainSetMethod <- CraftAndImputeTrain(trainSet) 
    trainSetMethod$TARGET_Quant <- data %>% pull(GA_page_views) %>% ntile(5) %>% as.factor()
    modelTargetQuantile <- svm(TARGET_Quant~.,trainSetMethod %>% select(-contains("IDEA"),-HY_id) ,kernel="radial")
    # 2.2 PROBABILISTIC NN
    nnDS <- trainSetEnriched %>%
        select(TARGET_Quant, everything())  %>% .[,1:5] %>%  as.matrix() %>% apply(2,as.numeric)
    spnna <- spnn::pnn.learn(nnDS,category.column = 1, sigma = cov(nnDS[,-1] ))
    spnna$sigma <- cov(nnDS[,-1])
    
    
    # spnn::pnn.guess(spnna,X = matrix(c(2.827,-6.42,12,1.46)))
    return(trainSetMethod)
    
} else if(section == "predict" ){
    browser()
    testSetMethod <- CraftAndImputePredict(trainSet,testSet)
    
   svmQuantilePred <-  predict(modelTargetQuantile, testSetMethod %>% 
                select(-contains("IDEA"),-HY_id)  %>% 
                select(TARGET,everything()) %>% select(-TARGET) )
   prob <- NULL
    for(r in 1:nrow(testSetMethod)){
        pi <- spnn::pnn.guess(spnna,X =( testSetMethod %>% fill(everything(),.direction = "up") %>% fill(everything(),.direction = "down") %>%
                                                          select(TARGET_Quant, everything()) %>% .[r,2:5] %>%  as.matrix() %>% apply(2,as.numeric)))$probabilities[2] %>% unname()
        prob <- c(prob,pi)
    }
   
    testSetMethod$TARGET_Quant <- cbind(SVM = svmQuantilePred, Spnn = prob) %>% mutate(Median = pmap_dbl(., lift_vd(median))) %>% pull(Median)
    return(testSetMethod)
} else if(section == "predict_ooSample"){
    trainSetMethod <- CraftAndImputeTrain(trainSet)
    testSetMethod <- CraftAndImputePredict(trainSet,testSet)
    return(list(test = testSetMethod%>% arrange(HY_id),
                train = trainSetMethod%>% arrange(HY_id)))
}