#######################################
## ABC Random Forest Median Posterior##
#######################################

vars <- c("TARGET", "HY_provincia","HY_tipo", "HY_metros_totales", "HY_num_banos", "HY_num_terrazas",
          "HY_ascensor", "HY_trastero", "HY_num_garajes", "HY_precio","N_Quincenas", "DiffPerc_Precio", 
          "Precio_m2","Page_View_Per_Qincena", "Tiene_Fotos","Views_interaccion","Views_interaccion","Cluster",'Precio_m2', 
          'Visitas_T_C','VisitasXquincena','HY_cert_energ')
if(nModels==5) roundsTries <- c(9,6,7,8,7) else roundsTries <- runif(nModels,6,9) 

if(section == "train"){
    trainSetMethod <- foldMethodList$models_0$baseCraft[[nm]] %>% 
        select(-HY_id)
    trainSetMethod %<>% select(one_of(vars), contains("Tiene"), contains("GA"), contains("Foto"),contains("Cluster")) #, contains("GA")
    
    trainSetMethod %<>% na.omit() 

    trainSetMethod <- QuitarOutliers(trainSetMethod,mode="filterOut",rounds=roundsTries[nm])
    
    abcRF <- abcrf::regAbcrf(TARGET ~., data = trainSetMethod, ntree=100)
    return(list(model = abcRF,
                trainset =trainSetMethod))
    
} else if(section == "predict" ){
    testSetMethod <-foldPredsList$models_0$baseCraft[[nm]] %>% 
        select(-HY_id) %>% 
        select(TARGET, everything()) %>% select(one_of(vars), contains("Tiene"), contains("GA"), contains("Foto"),contains("Cluster"))
    model <- allCVMethodListBaseModels[[cf]]$models_1$abcrf[[nm]]$model
    trainSetMethod <- allCVMethodListBaseModels[[cf]]$models_1$abcrf[[nm]]$trainset
    
    predictions <- predict(model, obs = testSetMethod, training =trainSetMethod, quantiles = c(0.2,0.7) )
    return(predictions$med)
    
} else if(section == "predict_ooSample"){
    testSetMethod <- ooSamplePredsList$models_0$baseCraft[[nm]]$test
    testSetMethod <- testSetMethod %>% 
        select(-HY_id) %>% select(TARGET, everything()) %>% select(one_of(vars), contains("Tiene"), contains("GA"), contains("Foto"),contains("Cluster"))
    
    trainSetMethod <- ooSamplePredsList$models_0$baseCraft[[nm]]$train
    trainSetMethod <- trainSetMethod %>% 
        select(-HY_id) %>% 
        select(TARGET, everything()) %>% select(one_of(vars), contains("Tiene"), contains("GA"), contains("Foto"),contains("Cluster")) %>% na.omit()
    trainSetMethod <- QuitarOutliers(trainSetMethod,mode="filterOut",rounds=roundsTries[nm])
    
    abcRF <- abcrf::regAbcrf(TARGET ~., data = trainSetMethod, ntree=150)
    predictions <- predict(abcRF, obs = testSetMethod, training =trainSetMethod, quantiles = c(0.2,0.7) )
    
    # Seleccionamos la mediana de las distribuciones
    
    return(predictions$med)
    
    
    
}
