###################################
## Catboost con nuevas variables ##
###################################

vars <- c("TARGET", "HY_provincia", "HY_tipo", "HY_metros_totales", "HY_num_banos", "HY_num_terrazas",
          "HY_ascensor", "HY_trastero", "HY_num_garajes", "HY_precio","N_Quincenas", "DiffPerc_Precio", 
          "Precio_m2","Page_View_Per_Qincena")

if(nModels==5) roundsTries <- c(7,7,7,9,9) else roundsTries <- runif(nModels,6,9) 
# depth <- runif(1,7,9) %>% round
# toleranceDev <- runif(1,1,2.1) 
toleranceDev <- 2
varsOut <- c("Tiene_Distribucion", "Cluster_TipoProvGA_GA_page_views", "Tiene_Descripcion","Cluster_TipoProvGA_VisitasXquincena",
             "Cluster_TipoProvGA_Num_Fotos","Tiene_Fotos", "Tiene_PrecioAnterior" ,
             "Cluster_TPPm2_VisitasXquincena" ,"Tiene_Certificado") 
if(section == "train"){
    trainSetMethod <- foldMethodList$models_0$baseCraft[[nm]]
    trainSetMethod %<>% select(-contains("IDEA"),-HY_id,-HY_cod_postal) %>% select(-one_of(varsOut)) %>% select(TARGET,everything()) 
    trainSetMethod %<>% na.omit() 
    
    # Despues de probar, quitamos los outliers antes de dividir entre train y validacion del catboost
    trainSetMethod <- QuitarOutliers(trainSetMethod,mode="filterOut",rounds=roundsTries[nm],toleranceDev = toleranceDev)
    trainSetMethodNew <- trainSetMethod %>% sample_frac(1.8,replace=T)
    validationSetMethod <- setdiff(trainSetMethod,trainSetMethodNew)
    
    train_pool <- catboost.load_pool(data = trainSetMethodNew %>% select(-TARGET), label = trainSetMethodNew %>% pull(TARGET))
    validation_pool <- catboost.load_pool(data = validationSetMethod%>% select(-TARGET), label = validationSetMethod%>% pull(TARGET))
    
    model <- catboost.train(train_pool,  validation_pool,
                            params <- list(iterations=10000,
                                           learning_rate=0.2,
                                           depth=7,
                                           loss_function='MAE',
                                           eval_metric='MAE',
                                           random_seed = seed,
                                           od_type='Iter',
                                           metric_period = 500,
                                           od_wait=30,
                                           use_best_model=TRUE))
    return(model)
    
} else if(section == "predict"){
    testSetMethod <- foldPredsList$models_0$baseCraft[[nm]]%>% arrange(HY_id)
    testSetMethod <- testSetMethod %>% select(-contains("IDEA"),-HY_id,-HY_cod_postal) %>% select(-one_of(varsOut)) %>% select(TARGET,everything())
    model <- allCVMethodListBaseModels[[cf]]$models_1$catboost_newCraft[[nm]]
    
    real_pool <- catboost.load_pool(testSetMethod[,-1])
    
    predictions <- catboost.predict(model, real_pool)
    
    return(pmax(predictions,0))
    
}  else if(section == "predict_ooSample"){
    testSetMethod <- ooSamplePredsList$models_0$baseCraft[[nm]]$test%>% arrange(HY_id)
    testSetMethod <- testSetMethod %>% select(-contains("IDEA"),-HY_id,-HY_cod_postal) %>% select(-one_of(varsOut)) %>% select(TARGET,everything()) 
    real_pool <- catboost.load_pool(testSetMethod[,-1])
    
    
    trainSetMethod <- ooSamplePredsList$models_0$baseCraft[[nm]]$train
    trainSetMethod <- trainSetMethod %>% select(-contains("IDEA"),-HY_id,-HY_cod_postal) %>% select(-one_of(varsOut)) %>% select(TARGET,everything())  %>% na.omit()
    
    trainSetMethod <- QuitarOutliers(trainSetMethod,mode="filterOut",rounds=roundsTries[nm],tolerance = toleranceDev)
    trainSetMethodNew <- trainSetMethod %>% sample_frac(1.8,replace=T)
    validationSetMethod <- setdiff(trainSetMethod,trainSetMethodNew)
    
    train_pool <- catboost.load_pool(data = trainSetMethodNew%>% select(-TARGET), label = trainSetMethodNew%>% pull(TARGET))
    validation_pool <- catboost.load_pool(data = validationSetMethod%>% select(-TARGET), label = validationSetMethod%>% pull(TARGET))
    
    model <- catboost.train(train_pool,  validation_pool,
                            params <- list(iterations=10000,
                                           learning_rate=0.2,
                                           depth=7,
                                           loss_function='MAE',
                                           eval_metric='MAE',
                                           random_seed = seed,
                                           od_type='Iter',
                                           metric_period = 500,
                                           od_wait=30,
                                           use_best_model=TRUE))
    predictions <- catboost.predict(model, real_pool)
    
    # Capamos las predicciones que esten por debajo de 0
    return(pmax(predictions,0))
    
}