#############################################
## XGB tuneado con funcion objetivo custom ##
#############################################

# Definimos la funcion objetivo custom
ln_cosh_obj <- function(preds, dtrain) {
    labels <- getinfo(dtrain, "label")
    grad <- tanh(preds-labels)
    hess <- 1-grad*grad
    return(list(grad = grad, hess = hess))
}
vars <- c("TARGET","HY_tipo", "HY_metros_totales", "HY_num_banos", "HY_num_terrazas",'HY_cert_energ',
          "HY_ascensor", "HY_trastero", "HY_num_garajes", "HY_precio", "N_Quincenas","Precio_m2","DiffPerc_Precio","Page_View_Per_Qincena",          
          "DensidadPob", "PIB_Capita","Tiene_Fotos","Views_interaccion","Cluster",'Precio_m2', 'Visitas_T_C','VisitasXquincena')

    params <- list(eta=0.1, max_depth=6, colsample_bylevel=0.66667,min_child_weight=1,subsample=0.6)
if(section == "train"){
                  
    trainSetMethod <- foldMethodList$models_0$baseCraft[[nm]]

    trainSetMethod %<>% select(one_of(vars), contains("GA"), contains("Tiene")) 
    trainSetMethod %<>% na.omit() 
    trainSetMethod <- QuitarOutliers(trainSetMethod,mode="filterOut",rounds=2)

    trainSetMethod <- trainSetMethod %>% bind_rows(trainSetMethod %>% sample_frac(0.1,replace = F))
    
    modelXGBtuned <- GetXGBTreeModel(trainSet_orig = trainSetMethod, obj=ln_cosh_obj, 
                                     seed = seed,mode = "CV")
    return(modelXGBtuned)
    
} else if(section == "predict"){
    
    testSetMethod <- foldPredsList$models_0$baseCraft[[nm]]%>% arrange(HY_id)
    testSetMethod <- testSetMethod %>% select(one_of(vars),contains("GA"), contains("Tiene"))
    model <- allCVMethodListBaseModels[[cf]]$models_1$xgb_tunnedCustom[[nm]]
    testSet_xgb <- xgb.DMatrix(data.matrix(testSetMethod[,-1]), label = data.matrix(testSetMethod[,1]))
    
    predictions <- predict(model$model, testSet_xgb)
    return(predictions)
    
}  else if(section == "predict_ooSample"){
    testSetMethod <- ooSamplePredsList$models_0$baseCraft[[nm]]$test %>% arrange(HY_id)
    testSetMethod <- testSetMethod %>% select(one_of(vars), contains("GA"), contains("Tiene"))
    trainSetMethod <- ooSamplePredsList$models_0$baseCraft[[nm]]$train
    trainSetMethod <- trainSetMethod %>% select(one_of(vars), contains("GA"), contains("Tiene")) %>% na.omit()
    trainSetMethod <- QuitarOutliers(trainSetMethod,mode="filterOut",rounds=4)
    trainSetMethod <- trainSetMethod %>% bind_rows(trainSetMethod %>% sample_frac(0.1,replace = F))
    
    model <- GetXGBTreeModel(trainSet_orig = trainSetMethod , obj=ln_cosh_obj, 
                             seed = seed,mode = "CV",params = params)
    testSet_xgb <- xgb.DMatrix(data.matrix(testSetMethod[,-1]), label = data.matrix(testSetMethod[,1]))
    
    predictions <- predict(model$model, testSet_xgb)
    return(pmax(predictions,0))
}

