#####################################
## XGB nrounds con Custom Function ##
#####################################

# Creamos la funcion de perdida custom
ln_cosh_obj <- function(preds, dtrain) {
    labels <- getinfo(dtrain, "label")
    grad <- tanh(preds-labels)
    hess <- 1-grad*grad
    return(list(grad = grad, hess = hess))
}

# roundsTries <- c(3,6,7,8,9)
if(nModels==5) roundsTries <- c(9,9,9,9,9) else roundsTries <- runif(nModels,6,9) 
# toleranceDev <- runif(1,1,2.1) 
# toleranceDev <- 1.7
toleranceDev <- 2
vars <- c("TARGET","HY_tipo", "HY_metros_totales", "HY_num_banos", "HY_num_terrazas",'HY_cert_energ',
          "HY_ascensor", "HY_trastero", "HY_num_garajes", "HY_precio", "N_Quincenas","Precio_m2","DiffPerc_Precio","Page_View_Per_Qincena",          
          "DensidadPob", "PIB_Capita","Tiene_Fotos","Views_interaccion","Cluster",'Precio_m2', 'Visitas_T_C','VisitasXquincena')

if(section == "train"){
    
    trainSetMethod %<>% select(one_of(vars), contains("GA"), contains("Tiene")) 
    trainSetMethod %<>% na.omit() 
    trainSetMethod <- QuitarOutliers(trainSetMethod,mode="filterOut",rounds=roundsTries[nm])
    
    trainSetMethod <- trainSetMethod %>% bind_rows(trainSetMethod %>% sample_frac(0.1,replace = F))
    
    modelXGBtuned <- GetXGBTreeModel(trainSet_orig = trainSetMethod, seed = seed,mode = "CV", obj=ln_cosh_obj)
    
    return(modelXGBtuned)
    
} else if(section == "predict"){
    
    testSetMethod <- foldPredsList$models_0$baseCraft[[nm]]%>% arrange(HY_id)
    testSetMethod <- testSetMethod %>% select(one_of(vars),contains("GA"), contains("Tiene"))
    model <- allCVMethodListBaseModels[[cf]]$models_1$xgb_tunnedCustom[[nm]]
    testSet_xgb <- xgb.DMatrix(data.matrix(testSetMethod[,-1]), label = data.matrix(testSetMethod[,1]))
    
    predictions <- predict(model$model, testSet_xgb)
    return(predictions)
    
}  else if(section == "predict_ooSample"){
    testSetMethod <- ooSamplePredsList$models_0$baseCraft[[nm]]$test %>% arrange(HY_id)
    testSetMethod <- testSetMethod %>% select(one_of(vars), contains("GA"), contains("Tiene"))
    trainSetMethod <- ooSamplePredsList$models_0$baseCraft[[nm]]$train
    trainSetMethod <- trainSetMethod %>% select(one_of(vars), contains("GA"), contains("Tiene")) %>% na.omit()
    trainSetMethod <- QuitarOutliers(trainSetMethod,mode="filterOut",rounds=roundsTries[nm])
    trainSetMethod <- trainSetMethod %>% bind_rows(trainSetMethod %>% sample_frac(0.1,replace = F))
    
    model <- GetXGBTreeModel(trainSet_orig = trainSetMethod, 
                             seed = seed,mode = "CV", obj=ln_cosh_obj)
    testSet_xgb <- xgb.DMatrix(data.matrix(testSetMethod[,-1]), label = data.matrix(testSetMethod[,1]))
    
    predictions <- predict(model$model, testSet_xgb)
    return(pmax(predictions,0))
}

