fairobj <- function(preds, dtrain) {
    labels <- getinfo(dtrain, "label")
    c <- 2  #the lower the "slower/smoother" the loss is. Cross-Validate.
    x <-  preds-labels
    grad <- c*x / (abs(x)+c)
    hess <- c^2 / (abs(x)+c)^2
    return(list(grad = grad, hess = hess))
}
vars <- c("TARGET", "HY_provincia", "HY_tipo", "HY_metros_totales", "HY_num_banos", "HY_num_terrazas",
          "HY_ascensor", "HY_trastero", "HY_num_garajes", "HY_precio")
if(section == "train"){
    trainSetMethod <- foldMethodList$models_0$base[[nm]]
    # trainSetMethod <- trainSetMethod %>% select(-HY_id) %>% select(TARGET, everything()) %>% 
    #     # select(TARGET, HY_cod_postal, HY_provincia, HY_tipo, HY_metros_utiles, HY_num_banos, HY_num_terrazas,
    #     #        HY_ascensor, HY_trastero, HY_num_garajes, HY_precio, contains("GA"))        
    #     select(TARGET, HY_provincia, HY_tipo, HY_metros_totales, HY_num_banos, HY_num_terrazas,
    #            HY_ascensor, HY_trastero, HY_num_garajes, HY_precio, contains("GA"), contains("Tiene"))
    trainSetMethod %<>% select(one_of(vars), contains("GA"), contains("Tiene")) 
    trainSetMethod %<>% na.omit() 
    # trainSetMethod %<>% filter(GA_page_views!=1) 
    
    modelXGBtuned <- GetXGBTreeModel(trainSet_orig = trainSetMethod, seed = seed,mode = "CV", obj=fairobj)
    return(modelXGBtuned)
    
} else if(section == "predict"){
    
    testSetMethod <- foldPredsList$models_0$base[[nm]]
    testSetMethod <- testSetMethod %>% select(one_of(vars),contains("GA"), contains("Tiene"))
    model <- allCVMethodListBaseModels[[cf]]$models_1$xgb_tunnedCustomFair[[nm]]
    testSet_xgb <- xgb.DMatrix(data.matrix(testSetMethod[,-1]), label = data.matrix(testSetMethod[,1]))
    
    predictions <- predict(model$model, testSet_xgb)
    return(predictions)
    
}  else if(section == "predict_ooSample"){
    testSetMethod <- ooSamplePredsList$models_0$base[[nm]]$test
    testSetMethod <- testSetMethod %>% select(one_of(vars), contains("GA"), contains("Tiene"))
    
    trainSetMethod <- ooSamplePredsList$models_0$base[[nm]]$train
    trainSetMethod <- trainSetMethod %>% select(one_of(vars), contains("GA"), contains("Tiene")) %>% na.omit()
    
    model <- GetXGBTreeModel(trainSet_orig = trainSetMethod, 
                             seed = seed,mode = "CV", obj=fairobj)
    testSet_xgb <- xgb.DMatrix(data.matrix(testSetMethod[,-1]), label = data.matrix(testSetMethod[,1]))
    
    predictions <- predict(model$model, testSet_xgb)
    
}