ln_cosh_obj <- function(preds, dtrain) {
    labels <- getinfo(dtrain, "label")
    grad <- tanh(preds-labels)
    hess <- 1-grad*grad
    return(list(grad = grad, hess = hess))
}
vars <- c("TARGET", "HY_provincia", "HY_tipo", "HY_metros_totales", "HY_num_banos", "HY_num_terrazas",
          "HY_ascensor", "HY_trastero", "HY_num_garajes", "HY_precio","N_Quincenas", "DiffPerc_Precio", 
          "Precio_m2","Page_View_Per_Qincena")
if(section == "train"){
    trainSetMethod <- foldMethodList$models_0$base[[nm]]
    trainSetMethod %<>% select(one_of(vars), contains("GA"), contains("Tiene")) 
    trainSetMethod %<>% na.omit() 
    poli <- polym(trainSetMethod[,2:10] %>% select_if(is.numeric) %>% as.matrix(), degree = 2, raw = T)
    poli2 <- polym(trainSetMethod[,10:20] %>% select_if(is.numeric) %>% as.matrix(), degree = 2, raw = T)
    poli3 <- polym(trainSetMethod[,20:25] %>% select_if(is.numeric) %>% as.matrix(), degree = 2, raw = T)
    poliFull <-   cbind(trainSetMethod$TARGET,poli,poli2,poli3,trainSetMethod %>% select_if(is.factor))
    # trainSetMethod <- trainSet %>% select(-HY_id) %>% select(TARGET, everything()) %>% 
    #     # select(TARGET, HY_cod_postal, HY_provincia, HY_tipo, HY_metros_utiles, HY_num_banos, HY_num_terrazas,
    #     #        HY_ascensor, HY_trastero, HY_num_garajes, HY_precio, contains("GA"))        
    #     select(TARGET, HY_provincia, HY_tipo, HY_metros_totales, HY_num_banos, HY_num_terrazas,
    #            HY_ascensor, HY_trastero, HY_num_garajes, HY_precio, contains("GA"), contains("Tiene"),
    #            N_Quincenas, DiffPerc_Precio, Precio_m2,Page_View_Per_Qincena)
    # trainSetMethod %<>% na.omit() 
    # trainSetMethod %<>% filter(GA_page_views!=1)
    
    modelXGBtuned <- GetXGBTreeModel(trainSet_orig = poliFull, seed = seed,mode = "CV", obj=ln_cosh_obj)
    return(modelXGBtuned)
    
} else if(section == "predict"){
    testSetMethod <- foldPredsList$models_0$base[[nm]]
    testSetMethod <- testSetMethod %>% select(one_of(vars),contains("GA"), contains("Tiene"))
    poli <- polym(testSetMethod[,2:10] %>% select_if(is.numeric) %>% as.matrix(), degree = 2, raw = T)
    poli2 <- polym(testSetMethod[,10:20] %>% select_if(is.numeric) %>% as.matrix(), degree = 2, raw = T)
    poli3 <- polym(testSetMethod[,20:25] %>% select_if(is.numeric) %>% as.matrix(), degree = 2, raw = T)
    poliFull <-   cbind(testSetMethod$TARGET,poli,poli2,poli3,testSetMethod %>% select_if(is.factor))
    
    model <- allCVMethodListBaseModels[[cf]]$models_1$xgb_tunnedCustomInteractions[[nm]]
    testSet_xgb <- xgb.DMatrix(data.matrix(poliFull[,-1]), label = data.matrix(poliFull[,1]))
    
    predictions <- predict(model$model, testSet_xgb)
    return(predictions)
    
}  else if(section == "predict_ooSample"){
    testSetMethod <- ooSamplePredsList$models_0$base[[nm]]$test
    testSetMethod <- testSetMethod %>% select(one_of(vars),contains("GA"), contains("Tiene"))
    poli <- polym(testSetMethod[,2:10] %>% select_if(is.numeric) %>% as.matrix(), degree = 2, raw = T)
    poli2 <- polym(testSetMethod[,10:20] %>% select_if(is.numeric) %>% as.matrix(), degree = 2, raw = T)
    poli3 <- polym(testSetMethod[,20:25] %>% select_if(is.numeric) %>% as.matrix(), degree = 2, raw = T)
    testSetMethod <-   cbind(testSetMethod$TARGET,poli,poli2,poli3,testSetMethod %>% select_if(is.factor))    
    
    trainSetMethod <- ooSamplePredsList$models_0$base[[nm]]$train
    trainSetMethod <- trainSetMethod %>% select(one_of(vars), contains("GA"), contains("Tiene")) %>% na.omit()
    poli <- polym(trainSetMethod[,2:10] %>% select_if(is.numeric) %>% as.matrix(), degree = 2, raw = T)
    poli2 <- polym(trainSetMethod[,10:20] %>% select_if(is.numeric) %>% as.matrix(), degree = 2, raw = T)
    poli3 <- polym(trainSetMethod[,20:25] %>% select_if(is.numeric) %>% as.matrix(), degree = 2, raw = T)
    trainSetMethod <-   cbind(trainSetMethod$TARGET,poli,poli2,poli3,trainSetMethod %>% select_if(is.factor))    
    model <- GetXGBTreeModel(trainSet_orig = trainSetMethod, #%>% filter(GA_page_views!=1) , 
                             seed = seed,mode = "CV", obj=ln_cosh_obj)
    testSet_xgb <- xgb.DMatrix(data.matrix(testSetMethod[,-1]), label = data.matrix(testSetMethod[,1]))
    
    predictions <- predict(model$model, testSet_xgb)
    
}

