########################################################
## XGB nrounds con Custom Function  y nuevas Variables##
########################################################

# Creamos la funcion de perdida custom
ln_cosh_obj <- function(preds, dtrain) {
    labels <- getinfo(dtrain, "label")
    grad <- tanh(preds-labels)
    hess <- 1-grad*grad
    return(list(grad = grad, hess = hess))
}
if(nModels==5) roundsTries <- c(4,7,7,8,8) else roundsTries <- runif(nModels,6,9) 
# roundsTries <- c(1,2,3,4,5)
# toleranceDev <- runif(1,1,2.1)
# toleranceDev <- 1.7
toleranceDev <- 2

if(section == "train"){
    trainSetMethod <- foldMethodList$models_0$baseCraft[[nm]] %>% 
        select(-HY_id) %>% select(TARGET, everything())

    trainSetMethod %<>% na.omit() %>% select(-contains("IDEA"),-contains("id"),-HY_cod_postal,HY_num_terrazas)
    
    # Despues de probar, quitamos los outliers antes de dividir entre train y validacion del catboost
    trainSetMethod <- QuitarOutliers(trainSetMethod,mode = "filterOut", rounds = roundsTries[nm])

    modelXGBtuned <- GetXGBTreeModel(trainSet_orig = trainSetMethod, seed = seed,mode = "CV", obj=ln_cosh_obj)
    return(modelXGBtuned)
    
} else if(section == "predict"){
    testSetMethod <- foldPredsList$models_0$baseCraft[[nm]] %>% arrange(HY_id) %>% 
        select(-HY_id) %>% select(TARGET, everything()) %>% select(-contains("IDEA"),-contains("id"),-HY_cod_postal,HY_num_terrazas)

    model <- allCVMethodListBaseModels[[cf]]$models_1$xgb_tunnedCustom_newCraft[[nm]]
    testSet_xgb <- xgb.DMatrix(data.matrix(testSetMethod[,-1]), label = data.matrix(testSetMethod[,1]))
    
    predictions <- predict(model$model, testSet_xgb)
    return(pmax(predictions,0))
    
}  else if(section == "predict_ooSample"){
    testSetMethod <- ooSamplePredsList$models_0$baseCraft[[nm]]$test %>% arrange(HY_id) 
    testSetMethod <- testSetMethod %>% 
        select(-HY_id) %>% select(TARGET, everything()) %>% select(-contains("IDEA"),-contains("id"),-HY_cod_postal,HY_num_terrazas)
    
    trainSetMethod <- ooSamplePredsList$models_0$baseCraft[[nm]]$train
    trainSetMethod <- trainSetMethod %>% 
        select(-HY_id) %>% select(TARGET, everything()) %>% na.omit()%>% select(-contains("IDEA"),-contains("id"),-HY_cod_postal,HY_num_terrazas)
    trainSetMethod <- QuitarOutliers(trainSetMethod,mode = "filterOut", rounds = roundsTries[nm])
    
    model <- GetXGBTreeModel(trainSet_orig = trainSetMethod, seed = seed,mode = "CV", obj=ln_cosh_obj)

    testSet_xgb <- xgb.DMatrix(data.matrix(testSetMethod[,-1]), label = data.matrix(testSetMethod[,1]))
    
    predictions <- pmax(predict(model$model, testSet_xgb),0)
    
}

