#############################################
##       XGB tuneado con gridsearch        ##
#############################################

if(section == "train"){
    trainSetMethod <- foldMethodList$models_0$baseCraft[[nm]] %>% 
        select(-HY_id) %>% select(TARGET, everything())
    trainSetMethod %<>% na.omit()%>% select(-contains("IDEA"),-contains("id"),-HY_cod_postal,HY_num_terrazas)
    trainSetMethod <- QuitarOutliers(trainSetMethod,mode="filterOut",rounds=7,tolerance = 2)
    params=list(eta = 0.05, colsample_bylevel=0.66667,
                subsample = 0.7, max_depth = 6,
                min_child_weigth = 1)
    MADE <- function(m,f){
        median(abs(m-f)) 
    }
    feval <- function(preds, dtrain){
        labels <- getinfo(dtrain, "label")
        err <- MADE(m = labels,f=preds)
        return(list(metric = "MADE", value = err))
    }
    xgb=xgboost(data=xgb.DMatrix(data.matrix(trainSetMethod[,-1]), label = data.matrix(trainSetMethod[,1])), 
                nrounds = 500, params = params, feval=feval )
    return(xgb)
    
} else if(section == "predict"){
    testSetMethod <- foldPredsList$models_0$baseCraft[[nm]] %>% 
        select(-HY_id) %>% select(TARGET, everything())%>% select(-contains("IDEA"),-contains("id"),-HY_cod_postal,HY_num_terrazas)
    
    model <- allCVMethodListBaseModels[[cf]]$models_1$xgb_tunned_hoptim[[nm]]
    testSet_xgb <- xgb.DMatrix(data.matrix(testSetMethod[,-1]), label = data.matrix(testSetMethod[,1]))
    
    predictions <- predict(model, testSet_xgb)
    return(pmax(predictions,0))
    
}  else if(section == "predict_ooSample"){
    
    params=list(eta = 0.05, colsample_bylevel=0.66667,
                subsample = 0.7, max_depth = 6,
                min_child_weigth = 1)
    MADE <- function(m,f){
        median(abs(m-f)) 
    }
    feval <- function(preds, dtrain){
        labels <- getinfo(dtrain, "label")
        err <- MADE(m = labels,f=preds)
        return(list(metric = "MADE", value = err))
    }
    
    testSetMethod <- ooSamplePredsList$models_0$baseCraft[[nm]]$test
    testSetMethod <- testSetMethod %>% 
        select(-HY_id) %>% select(TARGET, everything())%>% select(-contains("IDEA"),-contains("id"),-HY_cod_postal,HY_num_terrazas)
    
    trainSetMethod <- ooSamplePredsList$models_0$baseCraft[[nm]]$train
    trainSetMethod <- trainSetMethod %>% 
        select(-HY_id) %>% select(TARGET, everything()) %>% na.omit()%>% select(-contains("IDEA"),-contains("id"),-HY_cod_postal,HY_num_terrazas)
    trainSetMethod <- QuitarOutliers(trainSetMethod,mode="filterOut",rounds=7,tolerance = 2)
    model <- xgboost(data=xgb.DMatrix(data.matrix(trainSetMethod[,-1]), label = data.matrix(trainSetMethod[,1])), 
                             nrounds = 500, params = params, feval=feval)

    testSet_xgb <- xgb.DMatrix(data.matrix(testSetMethod[,-1]), label = data.matrix(testSetMethod[,1]))
    
    predictions <- pmax(predict(model, testSet_xgb),0)
    
}

