# Creamos la funcion objetivo custom
ln_cosh_obj <- function(preds, dtrain) {
    labels <- getinfo(dtrain, "label")
    grad <- tanh(preds-labels)
    hess <- 1-grad*grad
    return(list(grad = grad, hess = hess))
}
vars <- c("TARGET", "HY_provincia", "HY_tipo", "HY_metros_totales", "HY_num_banos", "HY_num_terrazas",
          "HY_ascensor", "HY_trastero", "HY_num_garajes", "HY_precio", "N_Quincenas","Precio_m2","DiffPerc_Precio","Page_View_Per_Qincena",          
          "DensidadPob", "PIB_Capita","Tiene_Fotos","Views_interaccion")
if(section == "train"){
    trainSetMethod <- foldMethodList$models_0$baseCraft_OneHot[[nm]]

    trainSetMethod %<>% select(-contains("IDEA"),-HY_id,-HY_cod_postal,-HY_provincia) %>% select(TARGET,everything()) 
    trainSetMethod %<>% na.omit() 
    trainSetMethod <- QuitarOutliers(trainSetMethod,mode = "filterOut", rounds = 3)
    
    modelXGBtuned <- GetXGBTreeModel(trainSet_orig = trainSetMethod, seed = seed,mode = "CV")
    return(modelXGBtuned)
    
} else if(section == "predict"){
    
    testSetMethod <- foldPredsList$models_0$baseCraft_OneHot[[nm]]
    testSetMethod <- testSetMethod %>% select(-contains("IDEA"),-HY_id,-HY_cod_postal,-HY_provincia)  %>% select(TARGET,everything()) 
    model <- allCVMethodListBaseModels[[cf]]$models_1$xgb_tunned_onehot[[nm]]
    testSet_xgb <- xgb.DMatrix(data.matrix(testSetMethod[,-1]), label = data.matrix(testSetMethod[,1]))
    
    predictions <- predict(model$model, testSet_xgb)
    return(predictions)
    
}  else if(section == "predict_ooSample"){
    testSetMethod <- ooSamplePredsList$models_0$baseCraft_OneHot[[nm]]$test
    testSetMethod <- testSetMethod %>% select(-contains("IDEA"),-HY_id,-HY_cod_postal,-HY_provincia)  %>% select(TARGET,everything()) 
    
    trainSetMethod <- ooSamplePredsList$models_0$baseCraft_OneHot[[nm]]$train
    trainSetMethod <- trainSetMethod %>% select(-contains("IDEA"),-HY_id,-HY_cod_postal,-HY_provincia)  %>% select(TARGET,everything())  %>% na.omit()
    trainSetMethod <- QuitarOutliers(trainSetMethod,mode = "filterOut", rounds = 3)
    
    model <- GetXGBTreeModel(trainSet_orig = trainSetMethod, 
                             seed = seed,mode = "CV", obj=ln_cosh_obj)
    testSet_xgb <- xgb.DMatrix(data.matrix(testSetMethod[,-1]), label = data.matrix(testSetMethod[,1]))
    
    predictions <- predict(model$model, testSet_xgb)
    
}
