ln_cosh_obj <- function(preds, dtrain) {
    labels <- getinfo(dtrain, "label")
    grad <- tanh(preds-labels)
    hess <- 1-grad*grad
    return(list(grad = grad, hess = hess))
}
vars <- c("TARGET", "HY_provincia", "HY_tipo", "HY_metros_totales", "HY_num_banos", "HY_num_terrazas",
          "HY_ascensor", "HY_trastero", "HY_num_garajes", "HY_precio","N_Quincenas", "DiffPerc_Precio", 
          "Precio_m2","Page_View_Per_Qincena")
if(section == "train"){
    trainSetMethod <- foldMethodList$models_0$base[[nm]]
    trainSetMethod %<>% select(one_of(vars), contains("GA"), contains("Tiene")) 
    trainSetMethod %<>% na.omit() 

    trainSetMethodNew <- trainSetMethod %>% sample_frac(1.6,replace=T)
    browser()
    model <- bas.lm(TARGET ~ .,
                    data = trainSetMethod,
                    method = "MCMC",
                    prior = "ZS-null",
                    modelprior = uniform())
    return(model)
    
} else if(section == "predict"){
    testSetMethod <- foldPredsList$models_0$base[[nm]]
    testSetMethod <- testSetMethod %>% select(one_of(vars),contains("GA"), contains("Tiene"))
    model <- allCVMethodListBaseModels[[cf]]$models_1$bayesreg[[nm]]
    
    predictions <- catboost.predict(model, testSetMethod)
    
    return(predictions)
    
}  else if(section == "predict_ooSample"){
    testSetMethod <- ooSamplePredsList$models_0$base[[nm]]$test
    testSetMethod <- testSetMethod %>% select(one_of(vars), contains("GA"), contains("Tiene"))
    
    
    trainSetMethod <- ooSamplePredsList$models_0$base[[nm]]$train
    trainSetMethod <- trainSetMethod %>% select(one_of(vars), contains("GA"), contains("Tiene")) %>% na.omit()
    trainSetMethodNew <- trainSetMethod %>% sample_frac(1.6,replace=T)
    
    model <-     model <- bas.lm(TARGET ~ .,
                                 data = trainSetMethod,
                                 method = "MCMC",
                                 prior = "ZS-null",
                                 modelprior = uniform())
    predictions <- predict(model, testSetMethod)
    return(predictions)
    
}
