#########
## SVM ##
#########
vars <- c("TARGET", "HY_provincia", "HY_tipo", "HY_metros_totales", "HY_num_banos", "HY_num_terrazas","HY_cert_energ",
          "HY_ascensor", "HY_num_garajes", "HY_precio","N_Quincenas", "DiffPerc_Precio", 
          "Precio_m2","Cluster",'Precio_m2', 'Visitas_T_C','VisitasXquincena')
if(section == "train"){
    trainSetMethod <- foldMethodList$models_0$baseCraft[[nm]]
    trainSetMethod %<>% select(-contains("IDEA"),-HY_id)   %>% select(TARGET,everything())
    trainSetMethod %<>% na.omit() 
    
    # Despues de probar, quitamos los outliers antes de dividir entre train y validacion del catboost
    trainSetMethod <- QuitarOutliers(trainSetMethod,mode="filterOut",rounds=5,toleranceDev = 2)
    
    trainSetMethod <- trainSetMethod %>% bind_rows(trainSetMethod %>% sample_frac(0.05,replace = F))
    model <- svm(TARGET~.,trainSetMethod,kernel="radial")
    return(model)
    
} else if(section == "predict"){
    testSetMethod <- foldPredsList$models_0$baseCraft[[nm]] %>% arrange(HY_id)
    testSetMethod <- testSetMethod %>% select(-contains("IDEA"),-HY_id)  %>% select(TARGET,everything())
    model_svm <- allCVMethodListBaseModels[[cf]]$models_1$svm[[nm]]
    
    predictions <- predict(model_svm, testSetMethod %>% select(-TARGET))
    
    return(predictions)
    
}  else if(section == "predict_ooSample"){
    testSetMethod <- ooSamplePredsList$models_0$baseCraft[[nm]]$test %>% arrange(HY_id)
    testSetMethod <- testSetMethod %>% select(-contains("IDEA"),-HY_id) %>% select(TARGET,everything())
    trainSetMethod <- ooSamplePredsList$models_0$baseCraft[[nm]]$train
    trainSetMethod <- trainSetMethod %>% select(-contains("IDEA"),-HY_id) %>% select(TARGET,everything()) %>% na.omit()
    # trainSetMethodNew <- trainSetMethod %>% sample_frac(1.6,replace=T)
    trainSetMethod <- QuitarOutliers(trainSetMethod,mode="filterOut",rounds=5,toleranceDev = 2,distOutlier = F)
    trainSetMethod <- trainSetMethod %>% bind_rows(trainSetMethod %>% sample_frac(0.05,replace = F))
    
    model_svm <- svm(TARGET~.,trainSetMethod,kernel="radial" )
    predictions <- predict(model_svm, testSetMethod %>% select(-TARGET))
    return(pmax(predictions,0))
    
}

