if(section == "predict_ooSample"){
    if(nm==nModels){
        
        trainStackDf <- allCVPredsListBaseModels[[1]][[2]] %>% 
            map_dfr(~ .x  %>% map(~ ifelse(.x < 0, 0, .x)), .id="Model") %>% select(Model, Observation, everything()) %>% 
            mutate(MeanPreds = pmap_dbl(select(.,-Model,-Observation), lift_vd(mean)),
                   MedianPreds = pmap_dbl(select(.,-Model,-Observation), lift_vd(median)),
                   MaxPreds = pmap_dbl(select(.,-Model,-Observation), lift_vd(max)) ,
                   MinPreds = pmap_dbl(select(.,-Model,-Observation), lift_vd(min)),
                   SdPreds = pmap_dbl(select(.,-Model,-Observation), lift_vd(sd)))
        
        for(i in 2:nFolds){
            trainStackDf <- bind_rows(trainStackDf,
                                      allCVPredsListBaseModels[[i]][[2]] %>% 
                map_dfr(~ .x  %>% map(~ ifelse(.x < 0, 0, .x)), .id="Model")%>% select(Model, Observation, everything()) %>% 
                    mutate(MeanPreds = pmap_dbl(select(.,-Model,-Observation), lift_vd(mean)),
                           MedianPreds = pmap_dbl(select(.,-Model,-Observation), lift_vd(median)),
                           MaxPreds = pmap_dbl(select(.,-Model,-Observation), lift_vd(max)) ,
                           MinPreds = pmap_dbl(select(.,-Model,-Observation), lift_vd(min)),
                           SdPreds = pmap_dbl(select(.,-Model,-Observation), lift_vd(sd)))) 
        }
        
        trainStackDf %<>% select(Model,Observation,contains("Preds")) %>%  group_by(Model) %>%
            nest() %>%
            select(data) %>% 
            unlist(recursive = F) %>% set_names(baseMethodsByLevel[[2]]) %>% 
            map2(.y=names(.), ~.x %>% rename_at(vars(-Observation), funs(paste(.,.y,sep="_"))))%>% 
            reduce(inner_join,by="Observation") %>% 
            inner_join(trainSet, by=c("Observation"="HY_id"))
        
        trainStackDf %<>% select(TARGET, Visitas_T_C , GA_page_views , MeanPreds_xgb_tunnedCustom , MeanPreds_catboost, MeanPreds_catboost_newCraft)
        rlm <-  train( form = TARGET ~ .,
                       metric = "MAE",
                       maxit=30,
                       data = trainStackDf ,
                       method = "rlm",
                       # preProc = c("center", "scale"),
                       # tuneLength = 15,
                       ## added:
                       # trControl = ctrl, 
                       verbose=T
        )
        
        
        procDf <- ooSamplePredsList[[2]] %>%
            map_dfr(~ .x  %>% map(~ ifelse(.x < 0, 0, .x)), .id="Model") %>% select(Model, Observation, everything()) %>% 
            mutate(MeanPreds = pmap_dbl(select(.,-Model,-Observation), lift_vd(mean)),
                   MedianPreds = pmap_dbl(select(.,-Model,-Observation), lift_vd(median)),
                   MaxPreds = pmap_dbl(select(.,-Model,-Observation), lift_vd(max)) ,
                   MinPreds = pmap_dbl(select(.,-Model,-Observation), lift_vd(min)),
                   SdPreds = pmap_dbl(select(.,-Model,-Observation), lift_vd(sd)))
        procDf %<>% select(Model,Observation,contains("Preds")) %>%  group_by(Model) %>%
            nest() %>%
            select(data) %>% 
            unlist(recursive = F) %>% set_names(baseMethodsByLevel[[2]]) %>% 
            map2(.y=names(.), ~.x %>% rename_at(vars(-Observation), funs(paste(.,.y,sep="_")))) %>% 
            reduce(inner_join,by="Observation") %>% 
            inner_join(testSet, by=c("Observation"="HY_id"))
        procDf%<>% select(Visitas_T_C , GA_page_views , MeanPreds_xgb_tunnedCustom , MeanPreds_catboost,MeanPreds_catboost_newCraft)
        
        predict(rlm,procDf)
        
        return(predict(rlm,procDf))
    }  
} 
