
# Fijamos la seccion, variable que marcara el comportamiento de los diferentes algoritmos(methods)
section = "train"
foldMethodList <- vector("list",length(baseMethodsByLevel)) %>% set_names(names(baseMethodsByLevel))

# Bucle de niveles
for(ml in seq_along(baseMethodsByLevel)){
    
    methods <- baseMethodsByLevel[[ml]]
    foldMethodList[[ml]]<- vector("list",length(methods)) %>% set_names(methods)
    
    # Bucle de methods por nivel
    for(method in methods){
        
        seed <- seed + 1
        flog.info(sprintf("Method : %s", method))
        nModelsMethodsList <- vector("list",length = nModels) %>% set_names(1:nModels)
        
        # Bucle de nModesl por cada method(algortimo)
        for(nm in 1:nModels){
            
            flog.info(sprintf("nModel : %s", nm))
            seed <- seed + nm
            set.seed(seed)
            # Llamada al algoritmo correspondiente
            nModelsMethodsList[[nm]] <- MethodSwitch(method)
            
        }
        
        # Vamos guardando cada method, el cual contiene nModels pasadas de cada modelo.
        foldMethodList[[ml]][[method]] %<>% append(nModelsMethodsList)
    }
}
